=== debian/watch ===
version=4
options=dversionmangle=s/\+dfsg//,uversionmangle=s/-?(beta|alpha|rc)/~$1/,repacksuffix=+dfsg,pgpsigurlmangle=s/$/.asc/ \
https://download.owncloud.com/desktop/stable/ owncloudclient-(.*)\.tar\.(?:bz2|xz)
